<template>
  <div
    v-if="isAdmin!=null"
    class="container-fluid"
  >
    <h1><users-icon />Ajouter une équipe</h1>
    <hr>
    <div
      class="row"
    >
      <div
        class="col-md-12"
        style="margin-bottom: 1vh;"
      >
        <input
          class="btn btn-primary"
          type="button"
          value="Retour"
          @click="$router.push({'path':'/admin/accueil?tab=2'})"
        >
      </div>
      <form
        id="teamForm"
        novalidate="novalidate"
      >
        <div class="row">
          <div class="col-xs-12 col-md-6">
            <div class="form-group required">
              <label
                for="description"
              >Nom&nbsp;:</label>
              <input
                id="description"
                v-model="description"
                name="description"
                type="description"
                class="form-control"
                required="required"
              >
            </div>
          </div>
          <div
            class="row"
            style="margin-top: 1em;"
          >
            <div
              class="col-xs-12"
              style="display: flex; flex-direction: column;"
            >
              <label style="text-align: center;">Domaine(s)</label>
              <el-transfer
                v-model="selectedBusinesses"
                style="margin: auto; width: 100%;"
                :data="availableBusinesses"
                :titles="['Disponible(s)', 'Autorisée(s)']"
                :props="{
                  key: 'id',
                  label: 'email'
                }"
                filterable
                :filter-method="filterBusinessesMethod"
                filter-placeholder="Rechercher"
              />
            </div>
          </div>
          <br>
          <div
            class="row"
            style="margin-top: 1em;"
          >
            <div
              class="col-xs-12"
              style="display: flex; flex-direction: column;"
            >
              <label style="text-align: center;">Gestionnaires(s)</label>
              <el-transfer
                v-model="selectedManagers"
                style="margin: auto; width: 100%;"
                :data="availableManagers"
                :titles="['Disponible(s)', 'Autorisée(s)']"
                :props="{
                  key: 'id',
                  label: 'email'
                }"
                filterable
                :filter-method="filterManagersMethod"
                filter-placeholder="Rechercher"
              />
            </div>
          </div>
          <br>
        </div>
        <div class="row">
          <div
            class="form-group btn-list"
          >
            <input
              class="btn btn-primary"
              :disabled="submitDisabled"
              type="submit"
              value="Créer une nouvelle équipe"
              @click="performTeam()"
            >
          </div>
        </div>
      </form>
    </div>
  </div>
  <div
    v-else
  >
    Vous n'avez pas la permission requise pour afficher ces informations.
  </div>
</template>

<script>
import UsersIcon from "../../../components/Icon/UsersIcon";
import {mapActions, mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";
export default {
  name: "AdminAddTeam",
  components: {UsersIcon},
  data() {
    return {
      selectedBusinesses: [],
      availableBusinesses: [],
      selectedManagers: [],
      availableManagers: [],
      validator: null,
      description: '',
    }
  },
  computed: {
    ...mapGetters([
      'isAdmin',
      'managers',
      'businesses',
    ]),
    submitDisabled: function() {
      return this.isLoading || this.description.length === 0;
    },
  },
  created() {
    this.fetchBusinesses().then(()=>{
      this.businesses.forEach(business => {
        this.availableBusinesses.push(business)
      })
    })
    this.fetchManagers().then(()=>{
      this.managers.forEach(manager => {
        this.availableManagers.push(manager)
      })
    })
  },
  mounted() {
    this.validator = $('#teamForm').submit(function (e) {
      e.preventDefault();
    }).validate({
      rules: {
        description: {
          required: true,
          maxlength: 250,
        }
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass('help-block');

        if (element.prop("type") === 'checkbox') {
          error.insertAfter(element.parent('label'));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'fetchBusinesses',
      'addManager',
      'addBusiness',
      'createTeam',
      'loadingStarts',
      'loadingEnds',
      'fetchManagers',
      'fetchTeams'
    ]),
    async addTeamManager(team) {
      for(const managerId of this.selectedManagers) {
        await this.addManager({
          teamId: team.id,
          managerId: managerId
        })
      }
    },
    async addTeamBusiness(team) {
      for(const businessId of this.selectedBusinesses) {
        await this.addBusiness({
          teamId: team.id,
          businessId: businessId
        })
      }
    },
    performTeam() {
      if ($("#teamForm").valid()) {
        this.loadingStarts()
        this.createTeam(this.description).then((team)=> {
          this.addTeamManager(team).then(()=>{
            this.addTeamBusiness(team).then(()=>{
              this.fetchTeams().then(()=>{
                VanillaToasts.create({
                  title: 'Ajout Équipe',
                  text: 'Équipe créée avec succès.',
                  type: 'success',
                  timeout: 10000,
                });
                this.loadingEnds()
                this.$router.push({ path: '/admin/accueil?tab=2'})
              })
            })
          })
        })
      }
    },
    filterBusinessesMethod(query, item) {
      return item.email.toLowerCase().indexOf(query.toLowerCase()) > -1;
    },
    filterManagersMethod(query, item) {
      return item.email.toLowerCase().indexOf(query.toLowerCase()) > -1;
    }
  }
}
</script>

<style scoped>

</style>